Bug 661536

Summary: globally uncaught exception when i click on Dashboard header link, but then quickly click on some other header link (e.g. Administration) before the Dashboard view has rendered
Product: [Other] RHQ Project Reporter: Ian Springer <ian.springer>
Component: Core UIAssignee: Jay Shaughnessy <jshaughn>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: high Docs Contact:
Priority: urgent    
Version: 4.0.0.B02CC: ccrouch, mazz, skondkar
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
See Also: https://bugzilla.redhat.com/show_bug.cgi?id=701973
Whiteboard:
Fixed In Version: 4.1 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-09-03 13:00:29 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 731034, 625146, 730796    

Description Ian Springer 2010-12-08 17:35:47 EST
Here's the JavaScript stack trace. It would be helpful to get the Java version of the stack trace from gwt debug mode.

Message Center : Globally uncaught exception
Severity : Fatal
Time : Wed 08 Dec 2010 05:30:27 PM EST
Detail :
com.google.gwt.core.client.JavaScriptException:(TypeError): this.selection is undefined stack: isc_TreeGrid_dataChanged()@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Grids.js:2727 anonymous()@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Core.js:44 isc_Tree_linkNodes([object Array],"id","parentId",null,(void 0),[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Grids.js:49 isc_ResultTree_loadChildrenReply([object Object],[object Array],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_DataBinding.js:1426 isc_c_Class_fireCallback([object Object],"dsResponse,data,dsRequest",[object Array],[object Object],(void 0))@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Core.js:293 isc_Class_fireCallback([object Object],"dsResponse,data,dsRequest",[object Array])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Core.js:389 isc_DataSource_fireResponseCallbacks([object Object],[object Object],(void 0),(void 0))@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_DataBinding.js:532 isc_DataSource__completeResponseProcessing([object Array],[object Object],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_DataBinding.js:529 isc_DataSource_processResponse("isc_AutodiscoveryQueueDataSource_13$627266",[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_DataBinding.js:381 com_smartgwt_client_data_DataSource_$processResponse__Lcom_smartgwt_client_data_DataSource_2Ljava_lang_String_2Lcom_smartgwt_client_data_DSResponse_2V([object Object],"isc_AutodiscoveryQueueDataSource_13$627266",[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:13023 org_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_AutodiscoveryQueueDataSource$1$1_onSuccess__Ljava_lang_Object_2V([object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:109249 com_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_$onResponseReceived__Lcom_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_2Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V([object Object],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:9032 org_rhq_enterprise_gui_coregui_client_util_rpc_TrackingRequestCallback_onResponseReceived__Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V([object Object],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:116193 com_google_gwt_http_client_Request_$fireOnResponseReceived__Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_RequestCallback_2V([object Object],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:4396 com_google_gwt_http_client_RequestBuilder$1_onReadyStateChange__Lcom_google_gwt_xhr_client_XMLHttpRequest_2V([object XMLHttpRequest])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:4620 ([object Event])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:12290 com_google_gwt_core_client_impl_Impl_entry0__Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2((function () {handler.onReadyStateChange__Lcom_google_gwt_xhr_client_XMLHttpRequest_2V(_this);}),[object XMLHttpRequest],[object Object])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:2479 ([object Event])@http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/D57240668A664A16A3643701D95E6DDD.cache.html:2468 fileName: http://localhost:7080/coregui/org.rhq.enterprise.gui.coregui.CoreGUI/sc/modules/ISC_Grids.js lineNumber: 2727
Comment 1 Charles Crouch 2011-08-12 12:25:03 EDT
Is this related to 701973
Comment 2 Ian Springer 2011-08-16 13:22:43 EDT
No, I don't think so. When the user switches from one top view to another (e.g. from Dashboard to Administration), we call destroy() on the first top view before drawing the new top view. My guess is that the dashboard view and all its portlet children has been destroyed by the time the fetch RPC call in AutodiscoveryQueueDataSource has returned, and so the call to processResponse() on the datasource fails because the ListGrid the datasource was bound to has been destroyed.

Bob B. is prototyping an impl of history-item-scoped uuids in RPC requests and responses for the purposes of discarding responses that have become obsolete due to the user navigating somewhere else. If that prototype is successful, it should fix this issue. Reassigning to Bob...
Comment 3 John Mazzitelli 2011-08-16 17:43:57 EDT
jay says this should be fixed
Comment 4 Jay Shaughnessy 2011-08-17 11:00:43 EDT
Master commit: b06d1811c26d285ca30101bcb3b8d775951da2b1

Anther variant of fast-click, this time specific to a bad assumption in the portlet/dash infrastructure.
Comment 5 Sunil Kondkar 2011-08-18 05:28:37 EDT
Verified on build#298 (Version: 4.1.0-SNAPSHOT Build Number: 66918cb)

Verified clicking rapidly between the Dashboard to Administration top views. Also tried fast clicking on other top views. No exception is observed. 
Marking as verified.
Comment 7 Heiko W. Rupp 2013-09-03 13:00:29 EDT
Bulk closing of old issues that are in VERIFIED state.